import { reactive as R, defineComponent as Bl, getCurrentInstance as Sl, ref as m, computed as K, onMounted as Hl, watchEffect as kl, toRefs as Al, resolveComponent as v, resolveDirective as qe, openBlock as d, createBlock as f, normalizeStyle as Ml, unref as Q, withCtx as o, createVNode as r, withDirectives as J, createElementVNode as ie, renderSlot as U, withKeys as Te, createElementBlock as S, Fragment as H, renderList as N, mergeProps as E, createTextVNode as k, toDisplayString as q, createCommentVNode as M, vShow as Ul, createSlots as We, resolveDynamicComponent as Rl, normalizeProps as Nl, guardReactiveProps as zl } from "vue";
import { ElNotification as Ol, ElMessage as Le, ElMessageBox as De } from "element-plus";
import { useRoute as $l } from "vue-router";
const G = {
  beforeSubmitHandler: "beforeSubmitHandler",
  beforedisabledHandler: "beforedisabledHandler",
  afterdisabledHandler: "afterdisabledHandler",
  beforeAddHandler: "beforeAddHandler",
  beforeEditHandler: "beforeEditHandler",
  beforeQueryHandler: "beforeQueryHandler",
  afterQueryHandler: "afterQueryHandler",
  beforeDeteleHandler: "beforeDeteleHandler",
  afterDeteleHandler: "afterDeteleHandler",
  beforeTableLazyHandler: "beforeTableLazyHandler"
};
function Il(p = { debug: !1 }) {
  const b = R({
    hooks: {}
  });
  return Object.keys(p).forEach((t) => {
    t !== "debug" && (b.hooks[t] = p[t]);
  }), {
    hookHandler: (t, B) => {
      let D = !1;
      try {
        p.debug && (console.group("DeBug\uFF1A", t), console.table(B.Data), console.groupEnd()), D = b.hooks[t](B);
      } catch {
        D = !0;
      }
      return D;
    }
  };
}
const te = (p, b = "success") => {
  Ol({
    title: p,
    type: b,
    offset: 70,
    duration: 2500
  });
};
function z(p) {
  let b;
  try {
    b = Array.isArray(p) ? [] : {}, p === null && (b = null);
  } catch {
    b = {};
  }
  for (const y in p)
    typeof p[y] == "object" ? b[y] = z(p[y]) : b[y] = p[y];
  return b;
}
function fe(p, b) {
  let y = z(p);
  for (var t in b)
    y.hasOwnProperty(t) && typeof b[t] == "object" ? y[t] = fe(y[t], b[t]) : y[t] = b[t];
  return y;
}
function Kl(p, b) {
  let y = {}, t = Object.getOwnPropertyNames(p), B = Object.getOwnPropertyNames(b);
  return t.length === B.length && t.forEach((D) => {
    p[D] !== b[D] && (y[D] = b[D]);
  }), y;
}
const ql = {
  debug: !1,
  IssearchForm: !1,
  labelWidth: 120,
  openIndex: !0,
  openMultipleSelection: !1,
  expand: !0,
  expandColumn: 4,
  menuWidth: 310,
  menuAlign: "left",
  dialogWidth: 800,
  editFooterButton: !0,
  fullscreen: !1,
  closeOnPressEscape: !0,
  destroyOnClosModal: !1,
  pageSizes: [10, 20, 50, 100],
  Pagination: {
    current: 1,
    pageSize: 10,
    total: 0
  },
  PaginationLayout: "->,total, sizes, prev, pager, next, jumper",
  hideOnSinglePage: !1,
  queryAfterMount: !1,
  apiName: {
    query: "query",
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  permission: {
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  permissions: ["add", "edit", "delete", "deleteFlag", "remove"]
};
let w = R({});
function T(...p) {
  w.debug && console.info("%c\u3010DeBug\u3011", "color:red", ...p);
}
const je = (p) => {
  w = fe(ql, p);
};
je({});
const Tl = /* @__PURE__ */ k(" \u65B0\u589E "), Wl = /* @__PURE__ */ k(" \u6279\u91CF\u5220\u9664 "), Ll = { class: "quick-search-area" }, jl = { style: { display: "flex", "justify-content": "flex-end" } }, Ql = /* @__PURE__ */ k("\u53D6\u6D88"), Jl = /* @__PURE__ */ k("\u91CD\u7F6E"), Gl = /* @__PURE__ */ k("\u63D0\u4EA4"), Xl = /* @__PURE__ */ Bl({
  __name: "index",
  props: {
    url: null,
    source: null,
    rowKey: null,
    rowKeys: null,
    keyName: null,
    AddInitID: null,
    watchData: null,
    hooks: null,
    wrapperStyle: null,
    tableHeight: null,
    tableAttributes: null,
    editFooterButton: { type: Boolean, default: () => w.editFooterButton },
    queryAfterMount: { type: Boolean, default: () => w.queryAfterMount },
    permission: { default: () => w.permissions },
    IssearchForm: { type: Boolean, default: () => w.IssearchForm },
    openIndex: { type: Boolean },
    openMultipleSelection: { type: Boolean, default: () => w.openMultipleSelection },
    expand: { type: Boolean, default: () => w.expand },
    expandColumn: { default: () => w.expandColumn },
    dialogWidth: { default: () => w.dialogWidth },
    fullscreen: { type: Boolean },
    closeOnPressEscape: { type: Boolean },
    destroyOnClosModal: { type: Boolean, default: () => w.destroyOnClosModal },
    PaginationLayout: { default: () => w.PaginationLayout },
    hideOnSinglePage: { type: Boolean, default: () => w.hideOnSinglePage }
  },
  emits: ["update:modelValue", "cell-click", "row-contextmenu"],
  setup(p, { expose: b, emit: y }) {
    const t = p;
    T("\u521D\u59CB\u5316\u540E\u7684\u3010\u7CFB\u7EDF\u53C2\u6570\u3011", w), T("\u3010Props\u53C2\u6570\u3011", t);
    const B = Sl(), D = $l(), O = m(), be = m(), Ve = m(), ve = m(), X = m("add"), W = m(!1), ae = m(!1), I = m(!1), Qe = m(t.editFooterButton), i = R({ ...fe(w, t.source.options) }), { hookHandler: L } = Il(t.hooks);
    let j = K(() => i.CrudRequest);
    const P = m({ filter: {}, editor: {}, column: {} }), Je = m(), ge = m(), we = m(), he = m(), xe = m(), g = m({}), Ge = m({}), h = m({}), me = m({}), Y = m([]), Xe = m([]), x = R({
      current: i.Pagination.current,
      pageSize: i.Pagination.pageSize,
      total: i.Pagination.total
    }), Z = m(0), _e = m(0), ye = m(0), oe = m(0);
    if ((() => {
      const { filter: l, editor: a, column: n, columns: c } = t.source;
      let F = {};
      l.forEach((C) => {
        c[C].searchDefaultValue !== void 0 ? F[C] = c[C].searchDefaultValue : F[C] = void 0, P.value.filter[C] = c[C];
      }), he.value = z(F), g.value = z(he.value);
      let le = {};
      a.forEach((C) => {
        c[C].addDefaultValue !== void 0 ? le[C] = c[C].addDefaultValue : le[C] = void 0, P.value.editor[C] = c[C];
      }), xe.value = z(le), n.forEach((C) => {
        P.value.column[C] = c[C];
      }), Je.value = c;
    })(), D.params.data) {
      T("\u8DEF\u7531\u4F20\u53C2\uFF1A", D.params.data);
      let l = D.params.data, a = JSON.parse(l);
      g.value = fe(g.value, a), T("searchModel", g);
    }
    const Ye = K(() => {
      let l = {};
      const a = ["el-input", "el-input-number", "el-select", "el-date-picker", "el-time-picker", "el-radio-group"];
      return t.source.filter.forEach((n) => {
        a.includes(P.value.filter[n].type) && (l[n] = P.value.filter[n]);
      }), l;
    }), Ze = K(() => {
      let l = {};
      const a = ["el-input", "el-input-number", "el-select", "el-date-picker", "el-time-picker", "el-cascader", "el-upload", "el-radio-group"];
      return t.source.editor.forEach((n) => {
        a.includes(P.value.editor[n].type) && $(P.value.editor[n], "visible") && (l[n] = P.value.editor[n]);
      }), l;
    }), el = K(() => ({ ...t.wrapperStyle })), ll = K(() => (x.current - 1) * x.pageSize + 1), al = K(() => {
      const l = m(0);
      return t.tableHeight ? l.value = t.tableHeight : i.IssearchForm ? l.value = _e.value : l.value = ye.value, l.value;
    }), Be = K(() => t.fullscreen ? oe.value - 50 : oe.value > 250 ? oe.value - Z.value * 0.3 : 250);
    Hl(() => {
      Z.value = document.documentElement.clientHeight, O.value.style.display = "block", _e.value = Z.value - 50 - 20 - 40 - 56 - be.value.clientHeight - O.value.clientHeight, O.value.style.display = "none", ye.value = Z.value - 50 - 20 - 40 - 56 - be.value.clientHeight, oe.value = Z.value - 54 - 62, t.queryAfterMount && V(), t.watchData && t.watchData.forEach((l) => {
        kl(() => {
          h.value[l.id] && (T("\u76D1\u542C\u7684id\u6570\u636E", h.value[l.id]), l.data.forEach((a) => {
            a.data[l.id] = h.value[l.id], T("\u76D1\u542C\u7684\u6570\u636E\u8BF7\u6C42", a), fl(a);
          }));
        });
      }), T("onMounted", _), T("Hight", { clientHeight: Z, OpenSearchFormtableMaxHeight: _e, CloseSearchFormtableMaxHeight: ye, EditFormMaxHeight: oe });
    });
    const Fe = (l) => {
      let a = {};
      return t.rowKey && (a[t.rowKey] = l[t.rowKey]), t.rowKeys && t.rowKeys.forEach((n) => {
        a[n] = l[n];
      }), a;
    }, re = (l) => l.formProps && l.formProps.type ? l.range ? l.formProps.type + "range" : l.formProps.type : "date", $ = (l, a) => {
      if (a === "disabled")
        return typeof l.disabled == "function" ? l.disabled(_, X.value) : !1;
      if (a === "visible")
        return typeof l.visible == "function" ? l.visible(_, X.value) : !0;
    }, ol = (l, a, n, c) => {
      y("cell-click", { row: l, column: a, cell: n, event: c });
    }, nl = (l, a, n, c) => {
      a.label && navigator.clipboard.writeText(n.innerText).then(() => {
        Le.success("\u590D\u5236\u6210\u529F\uFF01");
      });
    }, ul = (l, a, n) => {
      y("row-contextmenu", { row: l, column: a, event: n }, _);
    }, tl = (l) => {
      Y.value = l;
    }, rl = (l) => {
      let a = { ...l };
      return Object.keys(a).forEach((n) => {
        typeof a[n] == "function" && (a[n] = a[n].bind(this, _));
      }), a;
    }, sl = (l, a) => {
      let n = { ...l };
      return Object.keys(n).forEach((c) => {
        typeof n[c] == "function" && (n[c] = n[c].call(this, _, a));
      }), n;
    }, dl = (l) => {
      x.pageSize = l, V();
    }, pl = (l) => {
      x.current = l, x.current != null && V();
    }, cl = (l, a, n) => {
      if (a.type === "el-select") {
        const c = a.formProps.options.findIndex((F) => F.value == l.row[n]);
        return c === -1 ? l.row[n] : a.formProps.options[c].label;
      } else
        return l.row[n];
    }, il = () => {
      se.value.length && se.value.forEach((l) => {
        P.value.editor[l].formProps.fileList = [];
      });
    }, se = K(() => {
      let l = [];
      for (const a in P.value.editor)
        Object.prototype.hasOwnProperty.call(P.value.editor, a) && P.value.editor[a].type === "el-upload" && l.push(a);
      return l;
    }), fl = (l) => {
      j.value({ url: l.url, name: l.name, data: l.data }).then((a) => {
        P.value.editor[l.key].formProps.options = a.data.map((n) => {
          if (typeof l.label == "string")
            return {
              value: n[l.value],
              label: n[l.label]
            };
          if (typeof l.label == "object")
            return {
              value: n[l.value],
              label: n[l.label[0]] + "--" + n[l.label[1]]
            };
        });
      });
    }, V = () => {
      ae.value = !0;
      const l = R({
        ...g.value
      });
      for (const a in l)
        Object.prototype.hasOwnProperty.call(l, a) && typeof l[a] == "string" && (l[a] = l[a].trim(), l[a] === "" && (l[a] = void 0));
      !L(G.beforeQueryHandler, { CrudState: _, Data: l }) || j.value({
        url: t.url,
        name: i.apiName.query,
        data: {
          pagenum: x.current,
          pagesize: x.pageSize,
          ...l
        }
      }).then((a) => {
        const { data: n, page: c } = a;
        setTimeout(() => {
          bl(n, l), x.total = c.total, ae.value = !1;
        }, 50);
      }).catch(() => {
        ae.value = !1;
      });
    }, bl = (l, a) => {
      Object.keys(a).filter((c) => a[c] != null).length == 0 && (we.value = l), we.value = z(l), L(G.afterQueryHandler, { CrudState: _, Data: l }) && (ge.value = z(l));
    }, Se = () => {
      g.value = z(he.value), V();
    }, Ee = (l) => {
      !l || (l.resetFields(), se.value.length && se.value.forEach((a) => {
        const n = a + "UploadRef";
        (B == null ? void 0 : B.refs[n])[0].clearFiles();
      }));
    }, He = () => {
      h.value = z(xe.value);
      const l = R({ ...h.value });
      !L(G.beforeAddHandler, { CrudState: _, Data: l }) || (X.value = "add", W.value = !0);
    }, de = (l) => {
      const a = R({
        ...l
      });
      if (!L(G.beforeEditHandler, { CrudState: _, Data: a }))
        return;
      const n = z(a);
      Object.keys(n).forEach((c) => {
        h.value[c] = n[c], me.value[c] = n[c];
      }), X.value = "edit", W.value = !0;
    }, ee = async (l) => {
      !l || await l.validate((a) => {
        if (a) {
          const n = R({
            ...h.value
          });
          if (!L(G.beforeSubmitHandler, { CrudState: _, Data: n }))
            return;
          _.Mode === "add" ? ke(n) : Ae(n);
        }
      });
    }, ke = (l) => {
      I.value = !0;
      let a = l;
      l.FormData instanceof FormData && (a = l.FormData), j.value({ url: t.url, name: i.apiName.add, data: a }).then(() => {
        W.value = !1, te("\u65B0\u589E\u6210\u529F"), V(), I.value = !1;
      }).catch(() => {
        I.value = !1;
      });
    }, Ae = (l) => {
      I.value = !0;
      let a = l;
      if (l.FormData instanceof FormData)
        a = l.FormData;
      else {
        const n = Kl(me.value, a);
        if (JSON.stringify(n) === "{}")
          return I.value = !1, Le({ message: "\u6CA1\u6709\u63D0\u4EA4\u9879\uFF01", grouping: !0 });
        a = {
          ...Fe(l),
          ...n
        };
      }
      j.value({ url: t.url, name: i.apiName.edit, data: a }).then(() => {
        W.value = !1, te("\u4FEE\u6539\u6210\u529F"), V(), I.value = !1;
      }).catch(() => {
        I.value = !1;
      });
    }, pe = (l) => {
      De.confirm(`\u786E\u5B9A\u8981 \u201C${l.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u201D \u8BE5\u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const a = R({
          row: { ...l },
          ...Fe(l),
          deleteFlag: l.deleteFlag == 0 ? 1 : 0
        });
        !L(G.beforedisabledHandler, { CrudState: _, Data: a }) || j.value({
          url: t.url,
          name: i.apiName.deleteFlag,
          data: a
        }).then(() => {
          te(`\u6570\u636E${l.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u6210\u529F`), V();
        });
      }).catch(() => {
      });
    }, ce = (l) => {
      De.confirm("\u786E\u5B9A\u8981\u5220\u9664\u672C\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const a = R({
          row: { ...l },
          ...Fe(l)
        });
        !L(G.beforeDeteleHandler, { CrudState: _, Data: a }) || j.value({
          url: t.url,
          name: i.apiName.delete,
          data: a
        }).then(() => {
          te("\u5220\u9664\u6210\u529F"), V();
        });
      }).catch(() => {
      });
    }, Me = () => {
      De.confirm("\u786E\u5B9A\u8981\u5220\u9664\u8FD9\u51E0\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const l = Y.value.map((a) => a[t.rowKey]);
        j.value({
          url: t.url,
          name: i.apiName.remove,
          data: { [t.rowKey]: l, selection: Y.value }
        }).then(() => {
          te("\u6279\u91CF\u5220\u9664\u6210\u529F"), Y.value = [], Ve.value.clearSelection(), V();
        });
      }).catch(() => {
      });
    }, _ = R({
      ElementArrs: P,
      tableData: ge,
      multipleSelection: Y,
      searchModel: g,
      searchFormValue: Ge,
      editModel: h,
      editFormValue: me,
      uploadFiles: Xe,
      tableLoading: ae,
      Pagination: x,
      Mode: X,
      queryRecord: V,
      refresh: Se,
      resetForm: Ee,
      addRecord: He,
      editRecord: de,
      handleSubmit: ee,
      handleAdd: ke,
      handleEdit: Ae,
      delFlag: pe,
      deleteRecord: ce,
      deleteMulRecord: Me
    });
    return b({
      ...Al(_)
    }), (l, a) => {
      const n = v("el-input"), c = v("el-form-item"), F = v("el-col"), le = v("el-input-number"), C = v("el-option"), Ue = v("el-select"), Ce = v("el-date-picker"), Re = v("el-time-picker"), Ne = v("el-radio"), ze = v("el-radio-button"), Oe = v("el-radio-group"), $e = v("el-row"), Ie = v("el-form"), vl = v("el-collapse-transition"), A = v("el-button"), gl = v("el-empty"), ne = v("el-table-column"), hl = v("el-descriptions-item"), ml = v("el-descriptions"), _l = v("el-button-group"), yl = v("el-table"), Fl = v("el-pagination"), El = v("el-cascader"), Cl = v("plus"), Dl = v("el-icon"), Pl = v("el-upload"), Vl = v("el-scrollbar"), Ke = v("el-card"), wl = v("el-dialog"), ue = qe("permission"), xl = qe("loading");
      return d(), f(Ke, {
        style: Ml([{ border: "0" }, Q(el)])
      }, {
        default: o(() => [
          r(vl, null, {
            default: o(() => [
              J(ie("div", {
                id: "plain",
                ref_key: "searchFormRef",
                ref: O
              }, [
                U(l.$slots, "search-form", {
                  editModel: g.value,
                  queryRecord: V,
                  CrudState: _
                }, void 0, !0),
                r(Ie, {
                  model: g.value,
                  "label-width": i.labelWidth,
                  onKeyup: Te(V, ["enter", "native"])
                }, {
                  default: o(() => [
                    r($e, null, {
                      default: o(() => [
                        U(l.$slots, "search-form-top", {
                          editModel: g.value,
                          queryRecord: V,
                          CrudState: _
                        }, void 0, !0),
                        (d(!0), S(H, null, N(Q(Ye), (e, s) => (d(), S(H, null, [
                          e.type === "el-input" ? (d(), f(F, {
                            key: 0,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: o(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: o(() => [
                                  r(n, E({
                                    style: { width: "100%" },
                                    modelValue: g.value[s],
                                    "onUpdate:modelValue": (u) => g.value[s] = u,
                                    clearable: "",
                                    placeholder: "\u6A21\u7CCA\u67E5\u627E"
                                  }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-input-number" ? (d(), f(F, {
                            key: 1,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: o(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: o(() => [
                                  r(le, E({
                                    style: { width: "100%" },
                                    modelValue: g.value[s],
                                    "onUpdate:modelValue": (u) => g.value[s] = u,
                                    placeholder: "\u8BF7\u8F93\u5165"
                                  }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-select" ? (d(), f(F, {
                            key: 2,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: o(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: o(() => [
                                  r(Ue, E({
                                    style: { width: "100%" },
                                    modelValue: g.value[s],
                                    "onUpdate:modelValue": (u) => g.value[s] = u,
                                    clearable: "",
                                    placeholder: "\u8BF7\u9009\u62E9"
                                  }, e.formProps), {
                                    default: o(() => [
                                      (d(!0), S(H, null, N(e.formProps.options, (u) => (d(), f(C, {
                                        key: u.value,
                                        label: u.label,
                                        value: u.value
                                      }, null, 8, ["label", "value"]))), 128))
                                    ]),
                                    _: 2
                                  }, 1040, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-date-picker" && re(e).includes("range") ? (d(), f(F, {
                            key: 3,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 12
                          }, {
                            default: o(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: o(() => [
                                  r(Ce, E({
                                    style: { width: "100%" },
                                    modelValue: g.value[s],
                                    "onUpdate:modelValue": (u) => g.value[s] = u,
                                    "start-placeholder": "\u8D77\u59CB",
                                    "range-separator": "\u81F3",
                                    "end-placeholder": "\u7ED3\u675F",
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    clearable: ""
                                  }, e.formProps, {
                                    type: re(e)
                                  }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-date-picker" && re(e) ? (d(), f(F, {
                            key: 4,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: o(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: o(() => [
                                  r(Ce, E({
                                    style: { width: "100%" },
                                    modelValue: g.value[s],
                                    "onUpdate:modelValue": (u) => g.value[s] = u,
                                    "start-placeholder": "\u8D77\u59CB",
                                    "range-separator": "\u81F3",
                                    "end-placeholder": "\u7ED3\u675F",
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    clearable: ""
                                  }, e.formProps, {
                                    type: re(e)
                                  }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-time-picker" ? (d(), f(F, {
                            key: 5,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: o(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: o(() => [
                                  r(Re, E({
                                    style: { width: "100%" },
                                    modelValue: g.value[s],
                                    "onUpdate:modelValue": (u) => g.value[s] = u,
                                    "start-placeholder": "\u8D77\u59CB",
                                    "range-separator": "\u81F3",
                                    "end-placeholder": "\u7ED3\u675F",
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    clearable: ""
                                  }, e.formProps, {
                                    "is-range": e.range
                                  }), null, 16, ["modelValue", "onUpdate:modelValue", "is-range"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-radio-group" ? (d(), f(F, {
                            key: 6,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: o(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: o(() => [
                                  r(Oe, E({
                                    modelValue: g.value[s],
                                    "onUpdate:modelValue": (u) => g.value[s] = u,
                                    disabled: $(e, "disabled")
                                  }, e.formProps), {
                                    default: o(() => [
                                      e.formProps.button ? M("", !0) : (d(!0), S(H, { key: 0 }, N(e.formProps.options, (u) => (d(), f(Ne, E({
                                        key: u.value,
                                        label: u.value
                                      }, e.formProps), {
                                        default: o(() => [
                                          k(q(u.label), 1)
                                        ]),
                                        _: 2
                                      }, 1040, ["label"]))), 128)),
                                      e.formProps.button ? (d(!0), S(H, { key: 1 }, N(e.formProps.options, (u) => (d(), f(ze, E({
                                        key: u.value,
                                        label: u.value
                                      }, e.formProps), {
                                        default: o(() => [
                                          k(q(u.label), 1)
                                        ]),
                                        _: 2
                                      }, 1040, ["label"]))), 128)) : M("", !0)
                                    ]),
                                    _: 2
                                  }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : M("", !0)
                        ], 64))), 256)),
                        U(l.$slots, "search-form-bottom", {
                          editModel: g.value,
                          queryRecord: V,
                          CrudState: _
                        }, void 0, !0)
                      ]),
                      _: 3
                    })
                  ]),
                  _: 3
                }, 8, ["model", "label-width", "onKeyup"])
              ], 512), [
                [Ul, i.IssearchForm]
              ])
            ]),
            _: 3
          }),
          ie("div", {
            ref_key: "buttonAreaRef",
            ref: be,
            class: "button_area"
          }, [
            J((d(), f(A, {
              type: "primary",
              icon: "plus",
              onClick: He
            }, {
              default: o(() => [
                Tl
              ]),
              _: 1
            })), [
              [ue, { permission: p.permission, access: [i.permission.add] }]
            ]),
            i.openMultipleSelection ? J((d(), f(A, {
              key: 0,
              disabled: Y.value.length <= 0,
              type: "danger",
              icon: "delete",
              onClick: Me
            }, {
              default: o(() => [
                Wl
              ]),
              _: 1
            }, 8, ["disabled"])), [
              [ue, { permission: p.permission, access: [i.permission.remove] }]
            ]) : M("", !0),
            U(l.$slots, "button-area", { CrudState: _ }, void 0, !0)
          ], 512),
          J((d(), f(yl, E({
            ref_key: "tableRef",
            ref: Ve,
            data: ge.value,
            "row-key": p.rowKey,
            height: Q(al),
            onCellClick: ol,
            onCellDblclick: nl,
            onRowContextmenu: ul,
            onSelectionChange: tl
          }, p.tableAttributes), {
            empty: o(() => [
              r(gl, {
                "image-size": 80,
                description: "\u6682\u65E0\u6570\u636E"
              })
            ]),
            default: o(() => [
              p.openMultipleSelection ? (d(), f(ne, {
                key: 0,
                type: "selection",
                "reserve-selection": "",
                width: 44
              })) : M("", !0),
              i.expand ? (d(), f(ne, {
                key: 1,
                type: "expand",
                width: 55
              }, {
                default: o((e) => [
                  r(ml, {
                    column: i.expandColumn,
                    border: ""
                  }, {
                    default: o(() => [
                      (d(!0), S(H, null, N(p.source.columns, (s, u) => (d(), S(H, { key: u }, [
                        s.hidden ? M("", !0) : (d(), f(hl, {
                          key: 0,
                          label: s.label
                        }, {
                          default: o(() => [
                            k(q(cl(e, s, u)), 1)
                          ]),
                          _: 2
                        }, 1032, ["label"]))
                      ], 64))), 128))
                    ]),
                    _: 2
                  }, 1032, ["column"])
                ]),
                _: 1
              })) : M("", !0),
              i.openIndex ? (d(), f(ne, {
                key: 2,
                label: "###",
                width: 55,
                "show-overflow-tooltip": ""
              }, {
                default: o(({ row: e, column: s, $index: u }) => [
                  k(q(Q(ll) + u), 1)
                ]),
                _: 1
              })) : M("", !0),
              (d(!0), S(H, null, N(P.value.column, (e, s) => (d(), f(ne, E({
                key: s,
                align: e.align || "left"
              }, e.tableProps, {
                label: e.label,
                prop: s,
                "show-overflow-tooltip": ""
              }), We({ _: 2 }, [
                e.columnSlot ? {
                  name: "default",
                  fn: o((u) => [
                    (d(), f(Rl(e.columnSlot.is), Nl(zl(sl(e.columnSlot, u))), null, 16))
                  ])
                } : void 0
              ]), 1040, ["align", "label", "prop"]))), 128)),
              U(l.$slots, "default", {}, void 0, !0),
              r(ne, {
                align: i.menuAlign || "left",
                width: t.keyName ? i.menuWidth : i.menuWidth - 150
              }, {
                header: o(() => [
                  ie("div", Ll, [
                    t.keyName ? (d(), f(n, {
                      key: 0,
                      style: { width: "150px" },
                      modelValue: g.value[t.keyName],
                      "onUpdate:modelValue": a[0] || (a[0] = (e) => g.value[t.keyName] = e),
                      placeholder: P.value.filter[t.keyName].label + "\u6A21\u7CCA\u67E5\u627E",
                      clearable: "",
                      onKeyup: Te(V, ["enter", "native"])
                    }, null, 8, ["modelValue", "placeholder", "onKeyup"])) : M("", !0),
                    r(_l, null, {
                      default: o(() => [
                        r(A, {
                          color: "#67c23a",
                          icon: "search",
                          onClick: V
                        }),
                        r(A, {
                          color: "#e6a23c",
                          icon: "refresh",
                          onClick: Se
                        }),
                        r(A, {
                          color: "#409eff",
                          icon: "expand",
                          onClick: a[1] || (a[1] = (e) => i.IssearchForm = !i.IssearchForm)
                        })
                      ]),
                      _: 1
                    })
                  ])
                ]),
                default: o((e) => [
                  U(l.$slots, "menu-top", {
                    scope: e,
                    delFlag: pe,
                    editRecord: de,
                    deleteRecord: ce,
                    CrudState: _
                  }, void 0, !0),
                  J((d(), f(A, {
                    plain: "",
                    type: e.row.deleteFlag ? "danger" : "success",
                    onClick: (s) => pe(e.row)
                  }, {
                    default: o(() => [
                      k(q(e.row.deleteFlag ? "\u7981\u7528" : "\u542F\u7528"), 1)
                    ]),
                    _: 2
                  }, 1032, ["type", "onClick"])), [
                    [ue, { permission: p.permission, access: [i.permission.deleteFlag] }]
                  ]),
                  J(r(A, {
                    plain: "",
                    type: "primary",
                    icon: "edit",
                    onClick: (s) => de(e.row)
                  }, null, 8, ["onClick"]), [
                    [ue, { permission: p.permission, access: [i.permission.edit] }]
                  ]),
                  J(r(A, {
                    type: "danger",
                    icon: "delete",
                    onClick: (s) => ce(e.row)
                  }, null, 8, ["onClick"]), [
                    [ue, { permission: p.permission, access: [i.permission.delete] }]
                  ]),
                  U(l.$slots, "menu-bottom", {
                    scope: e,
                    delFlag: pe,
                    editRecord: de,
                    deleteRecord: ce,
                    CrudState: _
                  }, void 0, !0)
                ]),
                _: 3
              }, 8, ["align", "width"])
            ]),
            _: 3
          }, 16, ["data", "row-key", "height"])), [
            [xl, ae.value]
          ]),
          r(Fl, {
            style: { "margin-top": "20px" },
            "hide-on-single-page": i.hideOnSinglePage,
            currentPage: x.current,
            "onUpdate:currentPage": a[2] || (a[2] = (e) => x.current = e),
            "page-size": x.pageSize,
            "onUpdate:page-size": a[3] || (a[3] = (e) => x.pageSize = e),
            "page-sizes": i.pageSizes,
            background: "",
            layout: i.PaginationLayout,
            total: x.total,
            onSizeChange: dl,
            onCurrentChange: pl
          }, null, 8, ["hide-on-single-page", "currentPage", "page-size", "page-sizes", "layout", "total"]),
          r(wl, {
            "custom-class": "DialogVisible",
            ref: "dialogRef",
            modelValue: W.value,
            "onUpdate:modelValue": a[7] || (a[7] = (e) => W.value = e),
            title: X.value === "add" ? "\u65B0\u589E" : "\u4FEE\u6539",
            width: i.dialogWidth,
            "destroy-on-close": "",
            "close-on-press-escape": i.closeOnPressEscape,
            fullscreen: i.fullscreen,
            "close-on-click-modal": i.destroyOnClosModal,
            onClosed: il
          }, We({
            default: o(() => [
              r(Ke, {
                class: "edit-form-card",
                shadow: "never"
              }, {
                default: o(() => [
                  r(Vl, {
                    height: Q(Be),
                    "max-height": Q(Be)
                  }, {
                    default: o(() => [
                      U(l.$slots, "edit-form", {
                        editModel: h.value,
                        handleSubmit: ee,
                        CrudState: _
                      }, void 0, !0),
                      r(Ie, {
                        id: "DialogVisible-edit-form",
                        class: "edit-form",
                        ref_key: "editFormRef",
                        ref: ve,
                        model: h.value,
                        "label-width": i.labelWidth
                      }, {
                        default: o(() => [
                          r($e, null, {
                            default: o(() => [
                              U(l.$slots, "edit-form-top", {
                                editModel: h.value,
                                handleSubmit: ee,
                                CrudState: _
                              }, void 0, !0),
                              (d(!0), S(H, null, N(Q(Ze), (e, s) => (d(), S(H, { key: s }, [
                                e.type === "el-input" ? (d(), f(F, {
                                  key: 0,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: o(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: o(() => [
                                        r(n, E({
                                          style: { width: "100%" },
                                          modelValue: h.value[s],
                                          "onUpdate:modelValue": (u) => h.value[s] = u,
                                          clearable: "",
                                          placeholder: "\u8BF7\u8F93\u5165",
                                          disabled: $(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-input-number" ? (d(), f(F, {
                                  key: 1,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: o(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: o(() => [
                                        r(le, E({
                                          style: { width: "100%" },
                                          modelValue: h.value[s],
                                          "onUpdate:modelValue": (u) => h.value[s] = u,
                                          clearable: "",
                                          placeholder: "\u8BF7\u8F93\u5165",
                                          disabled: $(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-select" ? (d(), f(F, {
                                  key: 2,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: o(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: o(() => [
                                        r(Ue, E({
                                          style: { width: "100%" },
                                          modelValue: h.value[s],
                                          "onUpdate:modelValue": (u) => h.value[s] = u,
                                          clearable: "",
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          disabled: $(e, "disabled")
                                        }, e.formProps), {
                                          default: o(() => [
                                            (d(!0), S(H, null, N(e.formProps.options, (u) => (d(), f(C, {
                                              key: u.value,
                                              label: u.label,
                                              value: u.value
                                            }, null, 8, ["label", "value"]))), 128))
                                          ]),
                                          _: 2
                                        }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-date-picker" ? (d(), f(F, {
                                  key: 3,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: o(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: o(() => [
                                        r(Ce, E({
                                          style: { width: "100%" },
                                          modelValue: h.value[s],
                                          "onUpdate:modelValue": (u) => h.value[s] = u,
                                          clearable: "",
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          disabled: $(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-time-picker" ? (d(), f(F, {
                                  key: 4,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: o(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: o(() => [
                                        r(Re, E({
                                          style: { width: "100%" },
                                          modelValue: h.value[s],
                                          "onUpdate:modelValue": (u) => h.value[s] = u,
                                          clearable: "",
                                          "start-placeholder": "\u8D77\u59CB",
                                          "range-separator": "\u81F3",
                                          "end-placeholder": "\u7ED3\u675F",
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          disabled: $(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-cascader" ? (d(), f(F, {
                                  key: 5,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: o(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: o(() => [
                                        r(El, E({
                                          style: { width: "100%" },
                                          modelValue: h.value[s],
                                          "onUpdate:modelValue": (u) => h.value[s] = u,
                                          props: e.formProps.props,
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          "show-all-levels": !1,
                                          disabled: $(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "props", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-upload" ? (d(), f(F, {
                                  key: 6,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: o(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: o(() => [
                                        r(Pl, E({
                                          style: { width: "100%" },
                                          ref_for: !0,
                                          ref: s + "UploadRef",
                                          action: ""
                                        }, rl(e.formProps)), {
                                          default: o(() => [
                                            e.formProps.listType !== "picture-card" ? (d(), f(A, {
                                              key: 0,
                                              type: "primary"
                                            }, {
                                              default: o(() => [
                                                k(q(e.formProps.butName || "\u9009\u62E9\u6587\u4EF6"), 1)
                                              ]),
                                              _: 2
                                            }, 1024)) : (d(), f(Dl, { key: 1 }, {
                                              default: o(() => [
                                                r(Cl)
                                              ]),
                                              _: 1
                                            }))
                                          ]),
                                          _: 2
                                        }, 1040)
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-radio-group" ? (d(), f(F, {
                                  key: 7,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: o(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: o(() => [
                                        r(Oe, E({
                                          modelValue: h.value[s],
                                          "onUpdate:modelValue": (u) => h.value[s] = u,
                                          disabled: $(e, "disabled")
                                        }, e.formProps), {
                                          default: o(() => [
                                            e.formProps.button ? M("", !0) : (d(!0), S(H, { key: 0 }, N(e.formProps.options, (u) => (d(), f(Ne, E({
                                              key: u.value,
                                              label: u.value
                                            }, e.formProps), {
                                              default: o(() => [
                                                k(q(u.label), 1)
                                              ]),
                                              _: 2
                                            }, 1040, ["label"]))), 128)),
                                            e.formProps.button ? (d(!0), S(H, { key: 1 }, N(e.formProps.options, (u) => (d(), f(ze, E({
                                              key: u.value,
                                              label: u.value
                                            }, e.formProps), {
                                              default: o(() => [
                                                k(q(u.label), 1)
                                              ]),
                                              _: 2
                                            }, 1040, ["label"]))), 128)) : M("", !0)
                                          ]),
                                          _: 2
                                        }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : M("", !0)
                              ], 64))), 128)),
                              U(l.$slots, "edit-form-bottom", {
                                editModel: h.value,
                                handleSubmit: ee,
                                CrudState: _
                              }, void 0, !0)
                            ]),
                            _: 3
                          })
                        ]),
                        _: 3
                      }, 8, ["model", "label-width"])
                    ]),
                    _: 3
                  }, 8, ["height", "max-height"])
                ]),
                _: 3
              })
            ]),
            _: 2
          }, [
            Qe.value ? {
              name: "footer",
              fn: o(() => [
                ie("div", jl, [
                  U(l.$slots, "edit-form-footer", {
                    CrudState: _,
                    resetForm: Ee,
                    handleSubmit: ee
                  }, void 0, !0),
                  r(A, {
                    onClick: a[4] || (a[4] = (e) => W.value = !1)
                  }, {
                    default: o(() => [
                      Ql
                    ]),
                    _: 1
                  }),
                  r(A, {
                    type: "warning",
                    plain: "",
                    onClick: a[5] || (a[5] = (e) => Ee(ve.value))
                  }, {
                    default: o(() => [
                      Jl
                    ]),
                    _: 1
                  }),
                  r(A, {
                    type: "primary",
                    loading: I.value,
                    onClick: a[6] || (a[6] = (e) => ee(ve.value))
                  }, {
                    default: o(() => [
                      Gl
                    ]),
                    _: 1
                  }, 8, ["loading"])
                ])
              ])
            } : void 0
          ]), 1032, ["modelValue", "title", "width", "close-on-press-escape", "fullscreen", "close-on-click-modal"])
        ]),
        _: 3
      }, 8, ["style"]);
    };
  }
});
const Yl = (p, b) => {
  const y = p.__vccOpts || p;
  for (const [t, B] of b)
    y[t] = B;
  return y;
}, Pe = /* @__PURE__ */ Yl(Xl, [["__scopeId", "data-v-e948326c"]]), Zl = {
  mounted(p, b, y) {
    const t = b.value.permission, B = b.value.access;
    let D = !1;
    for (let O = 0; O < B.length; O++)
      if (t.includes(B[O])) {
        D = !0;
        break;
      } else
        D = !1;
    D || p.parentNode && p.parentNode.removeChild(p);
  }
};
Pe.install = (p) => {
  p.component("CrudEl", Pe), p.directive("permission", Zl);
};
const oa = (p, b) => {
  b ? (b.CrudRequest || console.error("\u8BF7\u914D\u7F6E\u5168\u5C40\u8BF7\u6C42\u7684\u4E3B\u65B9\u6CD5\uFF1ACrudRequest"), je(b), p.use(Pe)) : console.error("\u8BF7\u521D\u59CB\u5316CrudEl\u914D\u7F6E\u9879");
};
export {
  fe as DataMerger,
  z as DeepClone,
  je as InitSys,
  oa as createCrudEl,
  G as hooksName,
  Kl as isObjEqual,
  Il as useHooks
};
